package Allegory.Alleg;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.Alleg.Lang.*;

public class AncTable extends TaBle<Database,Anc,AncTable> {
    @Override
    public String TupleTypeName() { return "Anc"; }

    public <TABLE> TABLE applyAnc(Function<AncTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public AncTable(Database db) {
        this(db,null);
    }

    public AncTable(Database db, Anc t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static AncTable BaseRelation(Database db) {
        AncTable tab = new AncTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Anc> tuples() {
        return tuples;
    }

    @Override
    public AncTable New() { return new AncTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Anc r = new Anc(t.get("id"));
       r._parOf = t.get("parOf");
       r._chldOf = t.get("chldOf");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Anc t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Anc t) {
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Anc,[id,parOf:Emp,chldOf:Emp]).");
    }

    @Override
    public String pformat() { return Anc.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (Anc a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,a.parOf.id.length());
          f2 = Math.max(f2,a.chldOf.id.length());
       }
       return String.format("Anc(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
