package Allegory.Alleg;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class Div extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "Div"; }

    public <TABLE> TABLE applyDiv(Function<Div,TABLE> f) { return f.apply(this); }

    public String name;

    public Div(String id, String name) {
       this.id = id;
       this.name = name;
    }

    // constructors used in database loading
    protected Div() {}

    private Div initFields(Tuple t) {
       id = t.get("id");
       name = t.get("name");
       return this;
    }

    public static Div make(Tuple t) {
       return new Div().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "Div(%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,name);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,name);
    }

    public DeptTable hasDept() {
       DeptTable result = new DeptTable(db);
       for(Dept a : db.Dept.tuples()) {
          if(a.inDiv==this) {
             result.add(a);
          }
       }
       return result; ///diamondRight
   }

}
