package Allegory.Alleg;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.Alleg.Lang.*;

public class JobTable extends TaBle<Database,Job,JobTable> {
    @Override
    public String TupleTypeName() { return "Job"; }

    public <TABLE> TABLE applyJob(Function<JobTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public JobTable(Database db) {
        this(db,null);
    }

    public JobTable(Database db, Job t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static JobTable BaseRelation(Database db) {
        JobTable tab = new JobTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<Job> tuples() {
        return tuples;
    }

    @Override
    public JobTable New() { return new JobTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       Job r = new Job(t.get("id"));
       r._employs = t.get("employs");
       r._worksin = t.get("worksin");
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(Job t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(Job t) {
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(Job,[id,employs:Emp,worksin:Dept]).");
    }

    @Override
    public String pformat() { return Job.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0;
       for (Job a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,a.employs.id.length());
          f2 = Math.max(f2,a.worksin.id.length());
       }
       return String.format("Job(!%ds,!%ds,!%ds).\n",f0,f1,f2).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

   /* the following methods cast a subtable into a supertable */

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
