package Allegory.Person;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.Person.Lang.*;

public class maleTable extends TaBle<Database,male,maleTable> {
    @Override
    public String TupleTypeName() { return "male"; }

    public <TABLE> TABLE applymale(Function<maleTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public maleTable(Database db) {
        this(db,null);
    }

    public maleTable(Database db, male t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static maleTable BaseRelation(Database db) {
        maleTable tab = new maleTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<male> tuples() {
        return tuples;
    }

    @Override
    public maleTable New() { return new maleTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       male r = new male(t.get("id"),t.get("fullName"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(male t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(male t) {
       db.person.cascadingDeleteLocal((person) t); // delete person associations
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(male,[id,'fullName']).");
    }

    @Override
    public String pformat() { return male.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0;
       for (male a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.fullName).length()+2);
       }
       return String.format("male(!%ds,!%ds).\n",f0,f1).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable fullName() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.fullName)));
       return st;
    }

   /* the following methods cast a subtable into a supertable */

   public personTable toPersonTable() {
      personTable tb = new personTable(db);
      for (person t : tuples()) { tb.add((person) t); }
      return tb;
   }

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
