package Allegory.startrek;

import PrologDB.Tuple;
import PrologDB.ErrorReport;
import java.util.function.Function;
import Meta4Framework.TuPle;

public class crewman extends TuPle<Database> {
    @Override
    public String TupleTypeName() { return "crewman"; }

    public <TABLE> TABLE applycrewman(Function<crewman,TABLE> f) { return f.apply(this); }

    public String fname;
    public String lname;
    public String species;

    public crewman(String id, String fname, String lname, String species) {
       this.id = id;
       this.fname = fname;
       this.lname = lname;
       this.species = species;
    }

    // constructors used in database loading
    protected crewman() {}

    private crewman initFields(Tuple t) {
       id = t.get("id");
       fname = t.get("fname");
       lname = t.get("lname");
       species = t.get("species");
       return this;
    }

    public static crewman make(Tuple t) {
       return new crewman().initFields(t);
    }

    @Override
    public void finishTuple(Database db, ErrorReport er) {
    }
    // end of methods used for loading a database

    static final String fmt = "crewman(%s,%s,%s,%s).\n";

    @Override
    public String toString() {
       return String.format(fmt,id,q(fname),q(lname),species);
    }

    @Override
    public String toString(String fmt) {
       return String.format(fmt,id,q(fname),q(lname),species);
    }

    public postTable onBoard() {
       postTable result = new postTable(db);
       for(asg r : db.asg.tuples()) {
          if(r.hasCrew==this && !result.contains(r.onBoard)) {
             result.add(r.onBoard);
          }
       }
       return result; // nmleft
    }

}
