package Allegory.startrek;

import PrologDB.Tuple;
import java.io.PrintStream;
import java.util.LinkedList;
import Meta4Framework.TaBle;
import java.util.function.Function;
import static Allegory.startrek.Lang.*;

public class medicalTable extends TaBle<Database,medical,medicalTable> {
    @Override
    public String TupleTypeName() { return "medical"; }

    public <TABLE> TABLE applymedical(Function<medicalTable,TABLE> f) { return f.apply(this); }

    // constructors for creating empty or singleton tables
    public medicalTable(Database db) {
        this(db,null);
    }

    public medicalTable(Database db, medical t) {
        this.db = db;
        initTupleList(t);
    }

    // methods for loading a database
    static medicalTable BaseRelation(Database db) {
        medicalTable tab = new medicalTable(db);
        tab.computedTable = false;
        return tab;
    }

    @Override
    public LinkedList<medical> tuples() {
        return tuples;
    }

    @Override
    public medicalTable New() { return new medicalTable(db); }

    @Override
    public void makeAndAdd(Tuple t) {
       medical r = new medical(t.get("id"),t.get("fname"),t.get("lname"),t.get("species"),t.get("specialty"));
       add(r);
    }

    @Override
    public boolean deleteFromSubTables(medical t) {
       return false;
    }

    @Override
    public void cascadingDeleteLocal(medical t) {
       db.crewman.cascadingDeleteLocal((crewman) t); // delete crewman associations
    }

    @Override
    public void mastHead(PrintStream out) {
        out.println("table(medical,[id,'fname','lname',species,specialty]).");
    }

    @Override
    public String pformat() { return medical.fmt; }

    @Override
    public String ppformat(boolean local) {
       int  f0=0, f1=0, f2=0, f3=0, f4=0;
       for (medical a : local?tuples:tuples()) {
          f0 = Math.max(f0,a.id.length());
          f1 = Math.max(f1,(""+a.fname).length()+2);
          f2 = Math.max(f2,(""+a.lname).length()+2);
          f3 = Math.max(f3,(""+a.species).length()+2);
          f4 = Math.max(f4,(""+a.specialty).length()+2);
       }
       return String.format("medical(!%ds,!%ds,!%ds,!%ds,!%ds).\n",f0,f1,f2,f3,f4).replace("!","%");
    }

    public STRINGTable id() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.id)));
       return st;
    }

    public STRINGTable fname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.fname)));
       return st;
    }

    public STRINGTable lname() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.lname)));
       return st;
    }

    public STRINGTable species() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.species)));
       return st;
    }

    public STRINGTable specialty() {
       STRINGTable st = new STRINGTable(db);
       tuples.forEach(t -> st.add(new STRING(t.specialty)));
       return st;
    }

    public postTable onBoard() {
       LinkedList<medical> tups = tuples();
       postTable result = new postTable(db);
       for(asg r : db.asg.tuples()) {
          if(tups.contains(r.hasCrew) && !result.contains(r.onBoard)) {
             result.add(r.onBoard);
          }
       }
       return result; // nmLeft
    }

   /* the following methods cast a subtable into a supertable */

   public crewmanTable toCrewmanTable() {
      crewmanTable tb = new crewmanTable(db);
      for (crewman t : tuples()) { tb.add((crewman) t); }
      return tb;
   }

   /* the following methods filter a supertable into a subtable */

   /* end of filtering methods */

}
