package Drivers.Alleg;

import Allegory.Alleg.Database;
import MDLUtilities.Marquee1In_1Out;
import PrologDB.ErrorReport;
import java.io.PrintStream;

public class Driver4Malta {

    public static void main() throws Exception {
        String[] args = { "test/Allegory/Alleg/TestData/x.alleg.pl" };
        main(args);
    }
    
    static void print(String s) { System.out.println(); System.out.println();
    System.out.println(s);System.out.println();}
    
    static PrintStream outt;
    public static void main(String... args) throws Exception {
        // Standard marquee processing
        Marquee1In_1Out mark = new Marquee1In_1Out(Driver4Malta.class, ".alleg.pl",".txt", args);
        String inputFileName = mark.getInputFileName();
        String outputFileName = mark.getOutputFileName();
        Database db = new Database(inputFileName);


        print("Q1) print all persons whose name begins with 'd' or 'p'");
        

        db.Emp
          .select(t -> t.name.startsWith("d") || t.name.startsWith("p"))
          .print();

        print("Q2) find divisions with Departments in Austin");
        
        db.Dept
          .select(d->d.city.equals("Austin"))
          .inDiv()
          .print();
        
        
        print("Q4) who are the division colleagues of priscila");
        
        db.Emp
          .select(t -> t.name.equals("priscila"))
          .worksin()
          .inDiv()
          .hasDept()
          .employs()
          .print();

        
        print("Constraints");
        ErrorReport er = new ErrorReport();

        print("C1) All emps have unique names");

        db.Emp.name()
              .duplicates()
              .error(er,"several Emp tuples have name '%s'",e->e.value);
        er.print();


        er.clear();
        
        print("C2) dept in toronto cannot hire emps younger that 19");
        
        db.Dept
          .select(d->d.city.equals("Toronto"))
          .forEach(d->d.employs().select(ee->ee.age<19)
                       .error(er,"%s illegally hired %s",e->d.name,e->e.name));
        er.print();
        
        
        er.clear();
    }
        
}
